exit_polling/poller_phx/lib/poller_phx_web/router.ex
defmodule PollerPhxWeb.Router do
  alias PollerPhxWeb.ChoiceController
  use PollerPhxWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
    plug PollerPhxWeb.Plugs.Auth
  end

  pipeline :api do
    plug :accepts, ["json"]
    plug :fetch_session
    plug PollerPhxWeb.Plugs.Auth
  end

  scope "/", PollerPhxWeb do
    pipe_through :browser

    get "/", PageController, :index
  end

  scope "/auth", PollerPhxWeb do
    pipe_through :browser

    get "/login", AuthController, :new
    post "/login", AuthController, :create
    delete "/logout", AuthController, :delete
  end

  scope "/districts", PollerPhxWeb do
    pipe_through [:browser, :valid_user, :admin_user]

    # get "/", DistrictController, :index
    # get "/new", DistrictController, :new
    # post "/", DistrictController, :create
    # get "/:id/edit", DistrictController, :edit
    # put "/:id", DistrictController, :update
    # delete "/:id", DistrictController, :delete

    # The below replaces the above
    resources "/", DistrictController, except: [:show]

    # Questions
    resources "/:district_id/questions", QuestionController, except: [:show]

    # Choices
    resources "/:district_id/questions/:question_id/choices", ChoiceController, except: [:show]
  end


  # Other scopes may use custom stacks.
  scope "/api", PollerPhxWeb.Api do
    pipe_through :api

    get "/districts", DistrictController, :index
    get "/districts/:district_id", DistrictController, :show
    get "/districts/:district_id/questions", QuestionController, :index
    get "/questions/:question_id/choices", ChoiceController, :index
  end

  scope "/api", PollerPhxWeb.Api do
    pipe_through [:api, :valid_user]

    get "/districts/:district_id/choices/:choice_id", ChoiceController, :vote
  end

  scope "/app", PollerPhxWeb do
    pipe_through :browser

    get "/*path", AppController, :index
  end
end

exit_polling/poller_phx/lib/poller_phx_web/controllers/api/question_controller.ex
defmodule PollerPhxWeb.Api.QuestionController do
  use PollerPhxWeb, :controller

  alias PollerDal.Questions

  def index(conn, %{"district_id" => district_id}) do
    questions = Questions.list_questions_by_district_id(district_id)
    render(conn, "index.json", questions: questions)
  end
end

exit_polling/poller_phx/lib/poller_phx_web/controllers/question_controller.ex
defmodule PollerPhxWeb.QuestionController do
  use PollerPhxWeb, :controller

  alias PollerDal.Questions
  alias PollerDal.Questions.Question
  alias PollerDal.Districts

  def index(conn, %{"district_id" => district_id}) do
    district = Districts.get_district!(district_id)
    questions = Questions.list_questions_by_district_id(district_id)
    render(conn, "index.html", district: district, questions: questions)
  end

  def new(conn, %{"district_id" => district_id}) do
    district = Districts.get_district!(district_id)
    changeset = Questions.change_question(%Question{})
    render(conn, "new.html", changeset: changeset, district: district)
  end

  def create(conn, %{"question" => question_params, "district_id" => district_id}) do
    question_params = Map.merge(question_params, %{"district_id" => district_id})

    case Questions.create_question(question_params) do
      {:ok, _question} ->
        conn
        |> put_flash(:info, "Question created successfully.")
        |> redirect(to: Routes.question_path(conn, :index, district_id))

      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  def edit(conn, %{"id" => id, "district_id" => district_id}) do
    district = Districts.get_district!(district_id)
    question = Questions.get_question!(id)
    changeset = Questions.change_question(question)

    render(conn, "edit.html",
      district: district,
      question: question,
      changeset: changeset
    )
  end

  def update(conn, %{"id" => id, "question" => question_params, "district_id" => district_id}) do
    question = Questions.get_question!(id)

    case Questions.update_question(question, question_params) do
      {:ok, _question} ->
        conn
        |> put_flash(:info, "Question updated successfully.")
        |> redirect(to: Routes.question_path(conn, :index, district_id))

      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "edit.html", question: question, changeset: changeset)
    end
  end

  def delete(conn, %{"id" => id, "district_id" => district_id}) do
    question = Questions.get_question!(id)
    {:ok, _question} = Questions.delete_question(question)

    conn
    |> put_flash(:info, "Question deleted successfully.")
    |> redirect(to: Routes.question_path(conn, :index, district_id))
  end
end

exit_polling/poller_phx/lib/poller_phx_web/views/question_view.ex
defmodule PollerPhxWeb.QuestionView do
  use PollerPhxWeb, :view
end

exit_polling/poller_phx/lib/poller_phx_web/templates/question/edit.html.eex
<h1>Edit Question</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.question_path(@conn, :update, @district.id, @question.id)) %>

exit_polling/poller_phx/lib/poller_phx_web/templates/question/form.html.eex
<%= form_for @changeset, @action, fn f ->  %>
  <%= if @changeset.action do %>
    <div class="error">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

  <%= label f, :description %>
  <%= text_input f, :description %>
  <%= error_tag f, :description %>

  <div>
    <%= submit "Save", class: "btn"  %>
    <%= link "Cancel", to: Routes.question_path(@conn, :index, @district.id), class: "btn-white"  %>
  </div>
<% end %>

exit_polling/poller_phx/lib/poller_phx_web/templates/question/index.html.eex
<h1>Poll Questions for <%= @district.name %></h1>

<table>
  <thead>
    <tr>
      <th colspan="2">Name</th>
    </tr>
  </thead>
  <tbody>
    <%= for question <- @questions do %>
      <tr>
        <td> <%= question.description %> </td>
        <td>
          <%= link to: Routes.choice_path(@conn, :index, @district.id, question.id) do %>
            <i class="fa fa-list"> </i>
          <% end %>
          <%= link to: Routes.question_path(@conn, :edit, @district.id, question) do %>
            <i class="far fa-edit"> </i>
          <% end %>
          <%= link to: Routes.question_path(@conn, :delete, @district.id, question.id),
            method: :delete,
            data: [confirm: "Are you sure?"]
            do
          %>
            <i class="fas fa-trash"> </i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<div>
  <%= link "Back", to: Routes.district_path(@conn, :index), class: "btn-white" %>
  <%= link "New question", to: Routes.question_path(@conn, :new, @district.id), class: "btn" %>
</div>

exit_polling/poller_phx/lib/poller_phx_web/templates/question/new.html.eex
<h1>New Question</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.question_path(@conn, :create, @district.id)) %>